//
///  <ID>$Id: c_array.h,v 1.2 2003/04/28 05:49:15 t Exp $</ID>
//
///  <COLLECTION>MakLib Code Library</COLLECTION>
//
///  <name>c_array.h</name>
//
///  <overview>
///  <jpn>萔TCY vector</jpn>
///  <eng>Container wrapper for constant-size vector. </eng>
///  </overview>
//
//    Copyright (c) 2003 Makino Takaki, t-libmak@snowelm.com
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#if !defined(__c_array_h)
#define __c_array_h

namespace mak {

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> c_array </name>

/// <overview>萔TCYvector</overview>
/// <desc>
/// <jpn>
/// <p>
/// ev[gƂăTCY^ vector łB
/// vector ɃANZX邱Ƃł܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>

/// <body>

template <class T, int max> 
class c_array
{
	T v[max];

public:
	typedef T value_type;

	typedef T* iterator;
	typedef const T* const_iterator;

	typedef T& reference;
	typedef const T& const_reference;

	typedef reverse_iterator<const_iterator> const_reverse_iterator;
	typedef reverse_iterator<iterator> reverse_iterator;

	operator T*() { return v; }
	operator const T*() const { return v; }

	c_array() { }
	~c_array() { }

	reference operator[](size_t i) { return v[i]; }
	const_reference operator[](size_t i) const { return v[i]; }

	iterator begin() { return v; }
	const_iterator begin() const { return v; }

	iterator end() { return v+max; }
	const_iterator end() const { return v+max; }

	ptrdiff_t size() const { return max; }
};

/// </body>
/// </classdef>

} // namespace mak

#endif	// __c_array_h
