//
///  <ID>$Id: except.h,v 1.3 2003/04/28 05:49:15 t Exp $</ID>
//
///  <COLLECTION>MakLib Code Library</COLLECTION>
//
///  <name>except.h</name>
//
///  <overview>
///  <jpn>ONX</jpn>
///  <eng>Header file for exception information class. </eng>
///  </overview>
//
//    Copyright (c) 2003 Makino Takaki, t-libmak@snowelm.com
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef __except_h
#define __except_h

#include <exception>
#include <typeinfo>

#include <string>

namespace mak {

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> exception_base </name>

/// <overview> Ox[XNX </overview>
/// <desc>
/// <jpn>
/// <p>
/// MakLib ŎgpÕx[XNXłB
/// OƂɂ͑gݍ݌^ exception 󂯎 what() ŗR悤
/// ƁAgݍ݃Cu̗O (new ̃mێsƂ) Lb`ł܂B
/// ̃R[hQƂĂB
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
///
/// <samp>
/// try {<br>
/// @@<em>(some code with exception)</em><br>
/// } <br>
/// catch( exception& e ) {<br>
/// @@cout << "Error! " << e.what() << endl;<br>
/// }<br>
/// </samp>
/// </desc>

/// <body>

class exception_base : public std::exception
{
	std::string _reason;
public:
	exception_base() : _reason("Exception of " + std::string(typeid(*this).name())) { }
		/// ̂Ȃ exception ܂B
	exception_base(std::string reason) : _reason(reason) { }
		/// <jpn>R <var>reason</var> ɂċNꂽO܂B</jpn>
		/// <eng>Construct an exception with reason <var>reason</var>.</eng>
	virtual ~exception_base() throw() { }
	virtual const char *what() const throw() { return _reason.c_str(); }
		/// <jpn>O̗R\擾܂B</jpn>
		/// <eng>Get a string that represents the reason of the exception.</eng>
};

/// </body>
/// </classdef>

} // namespace mak

#endif // __except_h
