//
///  <ID>$Id: hash_string.h,v 1.4 2003/04/28 07:11:54 t Exp $</ID>
//
///  <COLLECTION>MakLib Code Library</COLLECTION>
//
///  <name>hash_string.h</name>
//
///  <overview>
///  <jpn>hash_map&lt;string, ...&gt; ̂߂̃nbV֐̒`</jpn>
///  <eng>Definition of hash function for hash_map&lt;string, ...&gt;</eng>
///  </overview>
//
//    Copyright (c) 2003 Makino Takaki, t-libmak@snowelm.com
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef __hash_string_h
#define __hash_string_h

#include "config_maklib.h"

#ifdef LIBMAK_HAVE_HASH_MAP
#include <hash_map>
#endif
#ifdef LIBMAK_HAVE_EXT_HASH_MAP
#include <ext/hash_map>
#endif

#if ! defined(LIBMAK_HAVE_HASH_STRING)
/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> hash&lt;string&gt; </name>

/// <overview>string NXɑ΂nbV֐̒`</overview>
/// <desc>
/// <jpn>
/// <p>
/// string NXL[ƂnbV֐łBhash<const char *> ĂяoĂ܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see>prof</see>

/// <body>

#if defined(LIBMAK_HAVE_HASH_IN_GNU)
namespace __gnu_cxx {
#elif defined(LIBMAK_HAVE_HASH_IN_STD)
namespace std {
#endif

struct hash<std::string> {
  size_t operator()(const std::string __x) const { return __stl_hash_string(__x.c_str()); }
};

#if defined(LIBMAK_HAVE_HASH_IN_GNU)
}
#elif defined(LIBMAK_HAVE_HASH_IN_STD)
}
#endif

namespace mak {
#if defined(LIBMAK_HAVE_HASH_IN_GNU)
   typedef __gnu_cxx::hash<std::string> hash_string;
#elif defined(LIBMAK_HAVE_HASH_IN_STD)
   typedef std::hash<std::string> hash_string;
#endif
}

/// </body></classdef>

#endif // !LIBMAK_HAVE_HASH_STRING

#endif // __hash_string_h
