//
///  <ID>$Id: infinity.h,v 1.3 2003/04/28 07:11:54 t Exp $</ID>
//
///  <COLLECTION>MakLib Code Library</COLLECTION>
//
///  <name>infinity.h</name>
//
///  <overview>
///  <jpn>_̖ NaN ̒`</jpn>
///  <eng>Definition of NaN and Infinity for floating point value</eng>
///  </overview>
//
//    Copyright (c) 2003 Makino Takaki, t-libmak@snowelm.com
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef __infinity_h
#define __infinity_h
#include "config_maklib.h"

#ifdef LIBMAK_HAVE_CMATH
#include <cmath>
#else
#include <math.h>
#endif

namespace mak {

/////////////////////////////////////////////////////////////////////////

/// <constdef>
/// <name> NaN </name>

/// <overview>NaN (Not a Number)</overview>
/// <desc>
/// <jpn>
/// <p>
/// Not a Number \萔łB
/// l Not a Number ł邩ǂ x == NaN ł͔ł܂B
/// <ref>isNaN</ref> gĂB
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see>isNaN, infinity</see>

/// <body>

extern const double NaN;
/// </body></constdef>

/////////////////////////////////////////////////////////////////////////

/// <funcdef>
/// <name> isNaN </name>

/// <overview>NaN ̔</overview>
/// <desc>
/// <jpn>
/// <p>
/// l <var>x</var>  NaN (Not a Number) ł邩ǂ𔻒肵܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see>NaN</see>

/// <body>

inline bool isNaN(double x) { return x != x; }

/// </body></funcdef>


/////////////////////////////////////////////////////////////////////////

/// <constdef>
/// <name> Infinity </name>

/// <overview></overview>
/// <desc>
/// <jpn>
/// <p>
/// ̖\萔łB
/// ̖ -Infinity ƕ\܂B
/// ϐ x ̖ł邩ǂ x >= Infinity Ŕł܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see>NaN</see>

/// <body>
#if defined( HUGE_VAL )
const double Infinity = HUGE_VAL;
#else
extern const double Infinity;
#endif
/// </body></constdef>

}

#endif // __infinity_h
