//
///  <ID>$Id: initial.h,v 1.2 2003/04/28 05:49:15 t Exp $</ID>
//
///  <COLLECTION>MakLib Code Library</COLLECTION>
//
///  <name>initial.h</name>
//
///  <overview>
///  <jpn>/I</jpn>
///  <eng>Initialization and Termination</eng>
///  </overview>
//
//    Copyright (c) 2003 Makino Takaki, t-libmak@snowelm.com
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef __initial_h
#define __initial_h

namespace mak {
	
/// <notiondef>
///
/// <name> initial_overview </name>
/// <title> /I[` </title>
/// 
/// <desc>
/// 
/// <p> <ref>initial.h</ref> ɂ́AvŐNIɏs킹邽߂̃CuĂ܂B</p>
/// <ul>
/// <li> W[N邾ŁÃW[ɕKvȏ/Ȉs킹邱Ƃł܂B
/// <li> /Ȉwł܂Bʏ̑IuWFNg̃RXgN^/fXgN^gł
///      ̎w肪s\łB
/// <li> /I̊ԂɋNOߑł܂B
/// </ul>
/// <p>g͉̃TvB</p>
/// 
/// <samp>
/// #include "initial.h"<br>
/// <br>
/// int main()<br>
/// {<br>
/// @@<ref>Initializer</ref>::performAll();<br>
/// <br>
/// @@... (vO{)
/// <br>
/// @@<ref>Terminator</ref>::performAll();<br>
/// }<br>
/// <br>
/// <br>
/// class InitializeHoge : private Initializer<br>
/// {<br>
/// @@virtual void work();<br>
///	public:<br>
/// @@InitializeHoge() : Initializer(100) { }<br>
/// };<br>
/// static InitializeHoge initializerobj;<br>
/// void InitializeHoge::work()<br>
/// {<br>
/// @@... ()<br>
/// }<br>
/// <br>
/// class TerminateHoge : private Terminator<br>
/// {<br>
/// @@virtual void work();<br>
///	public:<br>
/// @@TerminateHoge() : Terminator(100) { }<br>
/// };<br>
/// static TerminateHoge Terminatorobj;<br>
/// void TerminateHoge::work()<br>
/// {<br>
/// @@... (I)<br>
/// }<br>
/// <br>

/// </samp>

/// </desc>
/// <see> Initializer, Terminator</see>
/// </notiondef>


/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> InitTermBase </name>

/// <overview> <jpn>/Ix[XNX</jpn><eng>Base class for initialization/termination</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// <ref>Initializer</ref> NX <ref>Terminator</ref> NX̋ʂ̒ۊNXłB
/// ƏIŕKvȃ[`ʉ邽߂ɍĂ܂B[U[ڑ삷邱Ƃ͂܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Initializer, Terminator </see>

/// <body>

class InitTermBase
{
	InitTermBase *next;
protected:
	int priority;

private:
	virtual void Work() = 0;

public:
	InitTermBase(InitTermBase **table, int ip);

	static void PerformAll(InitTermBase *table);
};

/// </body></classdef>


/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> Initializer </name>

/// <overview> <jpn>x[XNX</jpn><eng>Base class for initialization</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// ̂߂̒ۃNXłB̃NXpāAWork() ɏŕKvȏLqĂB
/// </p>
/// <p>
/// PɊ֐ĂԂȂ <ref>InitFunction</ref> ֗łB
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Terminator, InitFunction </see>

/// <body>

class Initializer : private InitTermBase
{
private:
	static InitTermBase *initable;

protected:
	virtual void Work() = 0;
		/// ̎sɂ̊֐Ă΂܂B
public:
	Initializer(int priority=100);
		/// e[uɂ̏֐o^܂B
		/// ۂ̏ (Work() ̌Ăяo)  PerformAll() Ă΂܂ōs܂B
		/// <var>priority</var> ͗DlłBDl̂ɏ܂B
		/// D揇ʂ̂̂ꍇ͏͕słB
	
	static void PerformAll();
		/// e[uɓo^ꂽׂĂ̏֐ADl̏̂珇Ɏs܂B
};

/// </body></classdef>


/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> Terminator </name>

/// <overview> <jpn>Ix[XNX</jpn><eng>Base class for initialization</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// Î߂̒ۃNXłB̃NXpāAWork() ɏIɕKvȏLqĂB
/// </p>
/// <p>
/// PɊ֐ĂԂȂ <ref>TermFunction</ref> ֗łB
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Initializer, TermFunction </see>

/// <body>

class Terminator : private InitTermBase
{
private:
	static InitTermBase *trmtable;

protected:
	virtual void Work() = 0;
		/// I̎sɂ̊֐Ă΂܂B
public:
	Terminator(int priority=100);
		/// Ie[uɂ̏I֐o^܂B
		/// ۂ̏I (Work() ̌Ăяo)  PerformAll() Ă΂܂ōs܂B
		/// <var>priority</var> ͗DlłBDl傫̂ɏI܂B
		/// D揇ʂ̂̂ꍇ͏͕słB
	
	static void PerformAll();
		/// Ie[uɓo^ꂽׂĂ̏I֐ADl̑傫̂珇Ɏs܂B
};

/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> InitFunction </name>

/// <overview> <jpn>֐ĂяoNX</jpn><eng>Initialization function caller</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// Initializer pꂽNXłB Work() ƂĎw肳ꂽ֐Ăяo܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Initializer, TermFunction </see>

/// <body>

class InitFunction : private Initializer 
{ 
	void (*func)();
	virtual void Work(); 

public: 
	InitFunction(void (*f)(), int priority=100);
		/// e[uɂ̏֐o^܂B
		/// ۂ̏ Work() ł́Aw肳ꂽ֐ <var>f</var> Ăяo܂B<var>f</var> ͈Ȃ
		/// void Ԃ悤Ȋ֐łȂ΂܂B<var>priority</var> ̂Ɏs܂B
}; 

/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> TermFunction </name>

/// <overview> <jpn>I֐ĂяoNX</jpn><eng>Initialization function caller</eng> </overview>
/// <desc>
/// <jpn>
/// <p>
/// Terminator pꂽNXłBI Work() ƂĎw肳ꂽ֐Ăяo܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// </p>
/// </eng>
/// </desc>
/// <see> Terminator, InitFunction </see>

/// <body>

class TermFunction : private Terminator
{ 
	void (*func)();
	virtual void Work(); 
public: 
	TermFunction(void (*f)(), int ip=100);
		/// Ie[uɂ̏֐o^܂B
		/// ۂ̏I Work() ł́Aw肳ꂽ֐ <var>f</var> Ăяo܂B<var>f</var> ͈Ȃ
		/// void Ԃ悤Ȋ֐łȂ΂܂B<var>priority</var> 傫̂Ɏs܂B
}; 
/// </body></classdef>

} // namespace mak

#endif
