//
///  <ID>$Id: memchk.h,v 1.2 2003/04/28 05:49:15 t Exp $</ID>
//
///  <COLLECTION>MakLib Code Library</COLLECTION>
//
///  <name>memchk.h</name>
//
///  <overview>
///  <jpn>ǗG[</jpn>
///  <eng>Memory management error checker</eng>
///  </overview>
//
//    Copyright (c) 2003 Makino Takaki, t-libmak@snowelm.com
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef __memchk_h
#define __memchk_h

/// <notiondef>
///
/// <name> memchk_overview</name>
/// <title> ǗG[[` </title>
/// 
/// <desc>
/// 
/// <p>
/// ̃Cu͑̃[`Ƃ͈قȂAfobO̎ɂp郋[`łB
/// </p><p>
/// #define DEBUG_MEM ăRpC memchk.o NƁAnew ZqAdelete 
/// Zq̓I[o[Ch܂B̏ԂŎsƁA̂悤Ȍʂ܂B
/// </p><ul>
/// <li>  new ŊmۂꂽƂɁAOɗ]ȃf[^Ċmۂ܂B
///      ̃f[^́Ã delete ŉꂽƂA<ref>SanityCheck</ref>
///      (ԂƂɌĂ΂鐮[`) ɂďĂȂǂ
///      ׂ܂BɂāAEI[o[imۂ̃TCYz
///      đOɏ݂Ăǰos܂B
/// <li>  delete ŉꂽƂɁA폜ꂽ̈Kȃf[^Ŗ߂܂B
///      ܂Ä̗́Adelete Ă΂ꂽサ΂炭̊ (̌ɉꂽf[^ <ref>countcheck</ref> ƂȂ܂ł̊)
///      ۂɂ͉ꂸɕێ܂B
///      ɂAꂽւ̃ANZXEd delete oł܂B
/// <li> vOIɁAĂȂubN̔ԍ񍐂܂B
///      ɂAdelete Y̌oł܂B
/// <li> ̂قAnew[] ŊmۂubN delete[] ł͂Ȃ delete ŉA
///      ƂoA񍐂܂B
/// </ul>
/// 
/// <p> ۂɎgƂɂ́Agdb 5.0 Ƒgݍ킹āÂ悤Ȏ菇ōs܂B
/// </p><ol>
/// <li> fobOvO͂炩 -g IvV (xłȂ -O0 (I[[) ōœK֎~)Agdb ŕKvȏ񂪊܂܂悤ɂĂ܂B
///      memchk.h ͂gKv͂܂B
///      ̃vOɁA#define DEBUG_MEM ăRpC memchk.o N܂B
/// <li> łst@CsƁAWG[o͂ɃG[bZ[W\܂B
///      ƂȂĂ镔 newc  delc ̒lL^Ă܂B
/// <li>  gdb găvOǂݍ݂܂B
/// <li> watch newcounter==<var>xxxx</var> ƂR}hŁAϐ <ref>newcounter</ref>  xxxx ɂȂƂɃvO
///      ~悤ɃEHb`|Cgݒ肵܂B(<ref>delcounter</ref> ɃEHb`|CgĂ܂܂)
/// <li> xAƑSiR}hCÁEEEjŎs܂B
///      ƁAS悤ɃmۂāASꏊŃ[NN͂łB
/// <li> vOEHb`|CgŒ~Abacktrace R}h new Zq̌Ăяo𒲂ׂ܂B
///      邱ƂŁAI[o[⃁[NNĂ{̃mۂ̏ꏊ˂~߂邱Ƃ
///      ł܂B
/// </ol>
///
/// <samp>mak% cat test.cpp</samp>  <span class=desc>fobOvO̓e</span><br>
/// <pre>#include &lt;iostream&gt;
/// #include &lt;string.h&gt;
/// 
/// char *copy(const char *src);
/// 
/// int main(int argc, char *argv[])
/// {
///         int i;
///         char **s = new char*[argc];
///         for( i=0; i&lt;argc; i++ )
///                 s[i] = copy(argv[i]);
///         for( i=0; i&lt;argc; i++ )
///                 cout &lt;&lt; s[i] &lt;&lt; endl;
///         for( i=0; i&lt;argc; i++ )
///                 delete[] s[i];
///         delete[] s;
/// }
/// 
/// char *copy(const char* src)
/// {
///         char *ret = new char[strlen(src)];
///         strcpy(ret, src);
///         return ret;
/// }</pre>
/// <samp>mak% </samp><kbd>g++ -o test -g -O0 test.cpp</kbd>  <span class=desc>-g -O0 ŃRpC</span><br>
/// <samp>mak% </samp><kbd>./test 3 abcdefghijklmnop hogehoge</kbd>  <span class=desc>sĂ݂ƂƓ</span><br>
/// <pre>./test
/// 3
/// abcdefghijklmnop
/// hogehoge
/// abcd</pre>
/// <samp>mak% </samp><kbd>./test asdfghjk abcdefghijkl</kbd>  <span class=desc>ʂ̈ƁEEE</span><br>
/// <pre>./test
/// asdfghjk
/// abcdefghijkl</pre>
/// <samp>Segmentation fault</samp>  <span class=desc>Segmentation fault o</span><br>
/// <samp>mak% gdb ./test</samp>  <span class=desc>Ƃ肠 gdb ɂĂ݂</span><br>
/// <pre>GNU gdb 5.0
/// This GDB was configured as "i686-pc-linux-gnu"...
/// (gdb) <kbd>run asdfghjk abcdefghijkl</kbd>   <span class=desc>G[N^Ă݂</span>
/// Starting program: /home/lyons/mak/mak/src/maklib/./test asdfghjk abcdefghijkl
/// /home/lyons/mak/mak/src/maklib/./test
/// asdfghjk
/// abcdefghijkl
/// 
/// Program received signal SIGSEGV, Segmentation fault.  <span class=desc>Č</span>
/// 0x40091129 in chunk_free (ar_ptr=0x40125d60, p=0x8058798) at malloc.c:3111
/// 3111    malloc.c: No such file or directory.
/// Current language:  auto; currently c
/// (gdb) <kbd>backtrace</kbd>   <span class=desc>X^bN\Ă݂</span>
/// #0  0x40091129 in chunk_free (ar_ptr=0x40125d60, p=0x8058798) at malloc.c:3111
/// #1  0x40090fba in __libc_free (mem=0x80587d0) at malloc.c:3023
/// #2  0x8051217 in __builtin_delete (ptr=0x80587d0) at ./cp/new2.cc:54
/// #3  0x804a69a in main (argc=3, argv=0xbffff4d4) at test.cpp:15  <span class=desc>ŋNĂ</span>
/// #4  0x4004f9cb in __libc_start_main (main=0x804a5a0 %lt;main%gt;, argc=3,
///     argv=0xbffff4d4, init=0x804a01c %lt;_init%gt;, fini=0x8053340 %lt;_fini%gt;,
///     rtld_fini=0x4000ae60 %lt;_dl_fini%gt;, stack_end=0xbffff4cc)
///     at ../sysdeps/generic/libc-start.c:92
/// (gdb) <kbd>quit</kbd>  <span class=desc>L͂ȏ񂪓Ȃ</span>
/// The program is running.  Exit anyway? (y or n) <kbd>y</kbd></pre>
/// <samp>mak% </samp><kbd>g++ -o test -g -O0 -DDEBUG_MEM test.cpp memchk.cpp</kbd>  <span class=desc>memchk </span><br>
/// <samp>mak% </samp><kbd>./test asdfghjk abcdefghijkl</kbd>  <span class=desc>s^</span><br>
/// <pre>Initialize memchk.cpp   <span class=desc>memchk.cpp gݍ܂Ă邱ƂbZ[W</span>
/// ./test
/// asdfghjk
/// abcdefghijkl
/// Internal error: delete[] for unknown (memory overrun?), newc=3, delc=2 <span class=desc>G[oBnewc  3 ł</span>
/// newcounter: 4
/// delcounter: 4
/// SanityCheckMEMORY Insane ... magic number not match  newc:3
/// leaking block newc = 3</pre>
/// <samp>mak% gdb ./test</samp>  <span class=desc> gdb ɂ</span><br>
/// <pre>GNU gdb 5.0
/// This GDB was configured as "i686-pc-linux-gnu"...
/// (gdb) <kbd>watch newcounter==3</kbd>         <span class=desc>newcounter  3 ɂȂƂ~܂悤EHb`|Cgݒ</span>
/// Hardware watchpoint 1: newcounter == 3
/// (gdb) <kbd>run asdfghjk abcdefghijkl</kbd>   <span class=desc>G[Nłx</span>
/// Starting program: /home/lyons/mak/mak/src/maklib/./test asdfghjk abcdefghijkl
/// Initialize memchk.cpp
/// Hardware watchpoint 1: newcounter == 3
/// 
/// Old value = false                            <span class=desc>EHb`|Cg̏</span>
/// New value = 1                                <span class=desc>ЂĎ~܂</span>
/// __builtin_vec_new (isize=8) at memchk.cpp:198
/// 198             if( (newcounter & (countcheck-1)) == 0 )
/// (gdb) <kbd>backtrace</kbd>
/// #0  __builtin_vec_new (isize=8) at memchk.cpp:198
/// #1  0x804a6dd in copy (src=0xbffff6b9 "asdfghjk") at test.cpp:21 <span class=desc></span>
/// #2  0x804a5d9 in main (argc=3, argv=0xbffff4d4) at test.cpp:11
/// #3  0x4004f9cb in __libc_start_main (main=0x804a580 &lt;main&gt;, argc=3,
///     argv=0xbffff4d4, init=0x8049fe8 &lt;_init&gt;, fini=0x80544d0 &lt;_fini&gt;,
///     rtld_fini=0x4000ae60 &lt;_dl_fini&gt;, stack_end=0xbffff4cc)
///     at ../sysdeps/generic/libc-start.c:92
/// (gdb) up   <span class=desc>ЂƂ̊Kwɂ</span>
/// #1  0x804a6dd in copy (src=0xbffff6b9 "asdfghjk") at test.cpp:21
/// 21              char *ret = new char[strlen(src)];
/// (gdb) list <span class=desc>21 sڕt߂̃\[X`FbN</span>
/// 16              delete[] s;
/// 17      }
/// 18
/// 19      char *copy(const char* src)
/// 20      {
/// 21              char *ret = new char[strlen(src)];
/// 22              strcpy(ret, src);
/// 23              return ret;
/// 24      }</pre>
/// <p> 21 sڂ new 悭݂ƁAstrlen  1 𑫂YĂ邱Ƃ킩܂B
///    lɂāA[Nd delete ƂAƂȂsȒPɓ˂~߂邱Ƃ
///    ł܂B</p>
/// </desc>
/// </notiondef>



/////////////////////////////////////////////////////////////////////////

/// <constdef>
/// <name> countcheck </name>

/// <overview>̌px</overview>
/// <desc>
/// <jpn>
/// <p>
/// newcounter  delcounter ̒l̔{ɒBƂAђԖgp
/// ubN̎ۂ̉s܂BK 2<sup>n</sup> ̌`ĂȂ΂܂B
/// 0 ɐݒ肷ƐіgpubN̉s܂B
/// ςȏꏊւ̃QƂ̃oOȂƂɂ͂̒l傫ĂB
/// </p>
/// </jpn>
/// </desc>
/// <see>delcounter, memchk_overview</see>

/// <body>

const int countcheck = 131072;

/// </body></constdef>

/////////////////////////////////////////////////////////////////////////

/// <vardef>
/// <name> newcounter </name>

/// <overview>new 񐔂̃JE^</overview>
/// <desc>
/// <jpn>
/// <p>
/// new  new[] AvON猻݂܂łɌĂ΂ꂽ񐔂łB-DDEBUG_MEM Ăꍇɂ̂ݎg܂B
/// vOŎgƂ͂܂񂪁A̕ϐɃEHb`|Cg邱ƂŁA
/// NĂ郁mۃ[`肷邱Ƃł܂B
/// </p>
/// </jpn>
/// </desc>
/// <see>delcounter, memchk_overview</see>

/// <body>

extern size_t newcounter;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////

/// <vardef>
/// <name> delcounter </name>

/// <overview>delete 񐔂̃JE^</overview>
/// <desc>
/// <jpn>
/// <p>
/// delete  delete[] AvON猻݂܂łɌĂ΂ꂽ񐔂łB-DDEBUG_MEM Ăꍇɂ̂ݎg܂B
/// vOŎgƂ͂܂񂪁A̕ϐɃEHb`|Cg邱ƂŁA
/// NĂ郁mۃ[`肷邱Ƃł܂B
/// </p>
/// </jpn>
/// </desc>
/// <see>delcounter, memchk_overview</see>

/// <body>

extern size_t delcounter;
/// </body></vardef>


/////////////////////////////////////////////////////////////////////////

/// <funcdef>
/// <name> SanityCheck </name>

/// <overview>̌</overview>
/// <desc>
/// <jpn>
/// <p>
/// ̐܂B-DDEBUG_MEM Ăꍇɂ̂ݎg܂B
/// IɌĂ΂ȂĂA񐔂 new 邢 delete ƂɌĂ΂Ă܂A
/// IɌĂԂƂœ̃[`̎ӂd_IɌł܂B
/// </p>
/// </jpn>
/// </desc>
/// <see>memchk_overview</see>

/// <body>

void SanityCheck() throw();

/// </body></funcdef>

#endif
