//
///  <ID>$Id: profile.h,v 1.6 2003/05/06 09:01:42 t Exp $</ID>
//
///  <COLLECTION>MakLib Code Library</COLLECTION>
//
///  <name>profile.h</name>
//
///  <overview>
///  <jpn>vt@C擾E</jpn>
///  <eng>Profiling routines </eng>
///  </overview>
//
//    Copyright (c) 2003 Makino Takaki, t-libmak@snowelm.com
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef __profile_h
#define __profile_h

#include "config_maklib.h"
#include <string>
#include "hash_string.h"

namespace mak {

/// <notiondef>
///
/// <name> profile_overview </name>
/// <title> vt@CO[` </title>
/// 
/// <desc>
/// 
/// <p> <ref>profile.h</ref> ɂ́AvO̓̃[`Ȁɂ鎞Ԃv邽߂̃CuĂ܂B</p>
/// 
/// <p>Ԃ𑪒肷ɂ́Â悤ɂāA֐Ȃǂ <ref>prof</ref> IuWFNg݂͂łB</p>
/// 
/// <samp>void f()<br>
/// {<br>
/// @@prof&lt;1&gt; pfobj ("function f");<br>
/// @@... /* ֐{ */<br>
/// }</samp><br>
///
/// <p>̂悤ȋLqɂAprof ^̃IuWFNg pfobj Ă폜܂Łȉ̗ꍇ͊֐ f() ɓĂo܂)
/// ̎ԂAjbg "function f" ƂČv܂Bjbg prof ŌvꂽԂ͎Iɗ݌vāAvȌIɈꗗɂȂďo͂܂B</p>
/// <p>i̓vt@CȂAƂǂׂ[`i悭gCC֐Ȃǁjꍇ́A
/// prof&lt;3&gt; ̂悤ɏڍדxw肵 prof ^g܂BRpC -DPROFILE=3 Ǝw肷ƁA
/// ڍדx 3 ȉ̂̂肳A4 ȏ݂̂̂͑Ȃ̂ƓlɈ܂B
/// </desc>
/// <see> prof </see>
/// </notiondef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> timeunit </name>

/// <overview>Ԃ\Pʂ̃NX</overview>
/// <desc>
/// <jpn>
/// <p>
/// vt@CԂ\߂̃NXłB
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see>prof</see>

/// <body>

typedef double timeunit;

/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <funcdef>
/// <name> GetTick </name>

/// <overview>oߎԂ̑</overview>
/// <desc>
/// <jpn>
/// <p>
/// vŐN猻݂܂ł̎ ([U[ CPU ) v܂B
/// Windows 95 ł͑肪ł܂B
/// vt@COŎgĂ܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see>prof</see>

/// <body>

timeunit GetTick() throw();

/// </body></funcdef>

#ifndef LIBMAK_PROFILE
#define LIBMAK_PROFILE 1
#endif


#if LIBMAK_PROFILE >= 1

#include <time.h>
#include <signal.h>

#include "except.h"

/////////////////////////////////////////////////////////////////////////

/// <constdef>
/// <name> profile_level </name>

/// <overview>vt@C̏ڍדxݒ肷萔</overview>
/// <desc>
/// <jpn>
/// <p>
/// 0 - 5 ͈̔͂ŁAǂꂾׂ͈͂vt@C邩w肵܂B
/// <var>x</var> ̐lȉ <ref>prof</ref>&gt;<var>x</var>&lt; N܂B
/// ܂Aprofile_level 傫ƁA葽 prof N悤ɂȂ܂B
/// Ή prof&gt;<var>x</var>&lt; vOɋLqĂȂӖ܂B
/// </p>
/// <p>
/// ύXɂ́ARpC -DPROFILE= Ɏw肷鐔lςăRpC܂B
/// 0 ɐݒ肷ƃvt@C͍s܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see>prof</see>

/// <body>

const int profile_level = LIBMAK_PROFILE + 0;

/// </body></constdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> exception_prof </name>

/// <overview>vt@CO</overview>
/// <desc>
/// <jpn>
/// <p>
/// vt@CɂO\߂̃NXłB
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see>prof</see>

/// <body>

class exception_prof : public mak::exception_base
{
public:
	exception_prof(std::string msg) throw() : exception_base("Profiler error: " +msg) { }
		///  msg ̃vt@CO\z܂B
};

/// </body></classdef>


/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> profunit </name>

/// <overview>jbgƂ̃vt@CWvNX</overview>
/// <desc>
/// <jpn>
/// <p>
/// evt@C jbgɂāAvt@CԂݐόvZ邽߂ɎgNXłB
/// [U[̃NX𒼐ڑ삷邱Ƃ͂܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>

/// <body>

class profunit
{
	unsigned long passcnt;
			/// ʂ
	timeunit alltime;
			/// S
	timeunit exctime;
			/// Tu[`O
	std::string name;
			/// jbg
	int	reentrantcnt;
			/// ēJEg (ċA֐̂)
	
public:
	profunit(std::string unitname) throw(): passcnt(1), alltime(0), exctime(0), name(unitname) {
			reentrantcnt = 1;
		 }
		 	/// jbg <var>unitname</var> ̐Vx[X쐬܂B
		 	/// Enter() ĂԕKv͂܂B

	const std::string &GetName() { return name; }
			/// jbg擾܂B
	void AddTime(timeunit t) { alltime += t; }
			/// SԂɎ <var>t</var> ݐς܂B
	void ExcTime(timeunit t) { exctime += t; }
			/// OԂɎ <var>t</var> ݐς܂B

	void Enter() { passcnt++; reentrantcnt++; }
			/// jbgɓƂ̏łB
	int Leave() { return --reentrantcnt; }
			/// jbgoƂ̏łBcċAԂ܂B

	unsigned long GetPassCount() { return passcnt; }
			/// ʉ߉񐔂擾܂B
	timeunit GetAllTime() { return alltime; }
			/// Ԃ擾܂B
	timeunit GetExcTime() { return exctime; }
			/// OԂ擾܂B

	std::ostream& output(std::ostream& os);
			/// ̃jbgɂẴvt@Cʂo͂܂B
};

/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name>profbase</name>

/// <overview><ref>prof</ref> ̃x[XNX</overview>
/// <desc>
/// <jpn>
/// <p>
/// <ref>prof</ref> ʂĊǗ邽߂̃x[XƂȂNXłB
/// 
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>

/// <body>

class profbase
{
	timeunit start_tick;
		/// ̃IuWFNg̊JnԂłB
		/// passive profiling ̏ꍇ́AIuWFNg̎ԂłB
	profbase *parent;
		/// ̌ĂяoƂłB
	profunit *my_unit;
		/// ̑ΏۂɂȂ郆jbgłB
		/// ݂̃vt@CΏۂłB

	void AddTime(timeunit t) { start_tick += t; }
		/// passive profiling ̏ꍇɁAԂ t ܂B

public:
	profbase(const char *n) throw();
		/// jbg n ̃vt@CJn܂B
	~profbase() throw();
		/// vt@CI܂B

	friend class profiler_t;
};


/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name>prof</name>

/// <overview>vt@CWv̂߂̈ꎞNX</overview>
/// <desc>
/// <jpn>
/// <p>
/// ̃IuWFNg쐬Ă܂ł̎ԂWvA<ref>profunit</ref> 
/// L^Ă܂B
/// ev[g LEVEL ɂ 1  5 ̏ڍדxw肵܂B̒lO[o萔 <ref>profile_level</ref>
/// (RpC -DPROFILE= Ŏw肳l) ȉ̂Ƃvt@Cs܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>

/// <body>

template <int LEVEL = 1>
class prof
 : public profbase
{
		
public:
	prof(const char *n) throw() : profbase(n) { }
		/// jbg n ̃vt@CJn܂B
	~prof() throw() { }
		/// vt@CI܂B
};

/// </body></classdef>

#ifndef LIBMAK_USE_UNUSED_ATTR
#define LIBMAK_USE_UNUSED_ATTR
#endif
template <> class prof< (profile_level+1) > { public: prof(const char *) throw() { } } LIBMAK_USE_UNUSED_ATTR ;
template <> class prof< (profile_level+2) > { public: prof(const char *) throw() { } } LIBMAK_USE_UNUSED_ATTR ;
template <> class prof< (profile_level+3) > { public: prof(const char *) throw() { } } LIBMAK_USE_UNUSED_ATTR ;
template <> class prof< (profile_level+4) > { public: prof(const char *) throw() { } } LIBMAK_USE_UNUSED_ATTR ;
template <> class prof< (profile_level+5) > { public: prof(const char *) throw() { } } LIBMAK_USE_UNUSED_ATTR ;

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name>profiler_t</name>

/// <overview>Ŝ̃vt@C𓝊NX</overview>
/// <desc>
/// <jpn>
/// <p>
/// vOŜ̃vt@CǗ܂B
/// profiler_t ^̃IuWFNǵAprofiler.cpp ̂Ȃőϐ profiler Ƃ
/// Ă܂B profiler ̃RXgN^Ă΂ĂfXgN^
/// Ă΂܂ł̊Ԃvt@C邱ƂɂȂ܂B
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <see> profiler </see>

/// <body>

class profiler_t
{
#ifdef LIBMAK_PASSIVE_PROFILE
#ifdef LIBMAK_USE_TIMER_SETTIME
	timer_t timerid;
#endif
	static void SIGALRM_Handler(int);
	
	struct sigaction oldact_SIGALRM;
	static const timeunit tickunit;
#endif

	int profile_block_count;
	profbase *totalprof;
	profbase *current;

public:
	profiler_t();
			/// vÕvt@CJn܂B
	~profiler_t();
			/// vÕvt@CI܂B

	profbase *GetCurrent() { return current; }
			/// ݃vt@CĂΏۂƂȂvt@CIuWFNg擾܂B
	void SetCurrent(profbase *p) { current = p; }
			/// ݃vt@CĂΏۂƂȂvt@CIuWFNgύX܂B

	void DisableProfiling() throw() { profile_block_count ++; }
			/// vt@CꎞIɒ~܂Bvt@CÔ߂ɕKv
			/// ubN DisableProfiling() ... EnableProfiling() ň͂ނƂŁA
			/// I[o[wbȟvł܂BDisableProfiling() 𕡐
			/// Ă񂾏ꍇ́A EnableProfiling() Ă΂Ȃƃvt@C
			/// ĊJ܂B
	void EnableProfiling() throw( exception_prof );
			/// vt@CĊJ܂BDisableProfiling() Ă΂ĂȂ̂
			/// EnableProfiling() Ă΂ꂽꍇAO𑗏o܂B
	bool IsProfiling() throw() { return profile_block_count == 0; }
			/// DisableProfiling() ĂȂǂ𒲂ׂ܂B
};

/// </body></classdef>

/// <vardef>
/// <name>profiler</name>
/// <overview>Ŝ̃vt@C𓝊IuWFNg</overview>
/// <desc>̃IuWFNg̐AɂāAvt@C̊JnAIIɍs܂B
/// ϐȂ̂ŁAvt@CNƎIɃvt@Cs邱ƂɂȂ܂B</desc>
/// <see> profiler_t </see>
/// <body>

extern profiler_t profiler;

/// </body></vardef>

#else	// PROFILE

template <int i> class prof { public: prof(const char *n) throw() { } };

typedef prof<1> prof;

#endif

} // namespace mak

#endif	// __profile_h
